(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('moment'), require('moment-hijri'), require('@angular/core'), require('@angular/forms'), require('@ng-bootstrap/ng-bootstrap'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-hijri-gregorian-datepicker', ['exports', 'moment', 'moment-hijri', '@angular/core', '@angular/forms', '@ng-bootstrap/ng-bootstrap', '@angular/common'], factory) :
    (factory((global['ngx-hijri-gregorian-datepicker'] = {}),global.momentjs,global.moment_,global.ng.core,global.ng.forms,global.ngBootstrap,global.ng.common));
}(this, (function (exports,momentjs,moment_,i0,forms,ngBootstrap,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/hijri-gregorian-datepicker/consts.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DateType = /** @class */ (function () {
        function DateType() {
        }
        DateType.Hijri = 1;
        DateType.Gregorian = 2;
        return DateType;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/hijri-gregorian-datepicker/date-formatter.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var momentHijri = moment_;
    var DateFormatterService = /** @class */ (function () {
        function DateFormatterService(parserFormatter) {
            this.parserFormatter = parserFormatter;
        }
        /**
         * @param {?} date
         * @return {?}
         */
        DateFormatterService.prototype.ToString = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                /** @type {?} */
                var dateStr = this.parserFormatter.format(date);
                return dateStr;
            };
        /**
         * @param {?} hijriDate
         * @return {?}
         */
        DateFormatterService.prototype.ToBindableHijroDate = /**
         * @param {?} hijriDate
         * @return {?}
         */
            function (hijriDate) {
                /** @type {?} */
                var hijriMomentDate = momentHijri(hijriDate, 'iD/iM/iYY HH:mm:ss tt');
                // Parse a Hijri date.
                /** @type {?} */
                var day = hijriMomentDate.iDate();
                /** @type {?} */
                var month = +hijriMomentDate.iMonth() + 1;
                /** @type {?} */
                var year = hijriMomentDate.iYear();
                /** @type {?} */
                var ngDate = new ngBootstrap.NgbDate(+year, month, +day);
                return ngDate;
            };
        /**
         * @param {?} hijriDate
         * @param {?} format
         * @return {?}
         */
        DateFormatterService.prototype.ToBindableHijroDateUsingFormat = /**
         * @param {?} hijriDate
         * @param {?} format
         * @return {?}
         */
            function (hijriDate, format) {
                /** @type {?} */
                var hijriMomentDate = momentHijri(hijriDate, format);
                // Parse a Hijri date based on format.
                /** @type {?} */
                var day = hijriMomentDate.iDate();
                /** @type {?} */
                var month = +hijriMomentDate.iMonth() + 1;
                /** @type {?} */
                var year = hijriMomentDate.iYear();
                /** @type {?} */
                var ngDate = new ngBootstrap.NgbDate(+year, month, +day);
                return ngDate;
            };
        /**
         * @param {?} date
         * @return {?}
         */
        DateFormatterService.prototype.ToHijri = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                if (!date) {
                    return null;
                }
                /** @type {?} */
                var dateStr = this.ToString(date);
                /** @type {?} */
                var momentDate = momentHijri(dateStr, 'D/M/YYYY');
                /** @type {?} */
                var day = momentDate.iDate();
                /** @type {?} */
                var month = +momentDate.iMonth() + 1;
                /** @type {?} */
                var year = momentDate.iYear();
                /** @type {?} */
                var ngDate = new ngBootstrap.NgbDate(+year, month, +day);
                return ngDate;
            };
        /**
         * @param {?} date
         * @return {?}
         */
        DateFormatterService.prototype.ToGregorian = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                if (!date) {
                    return null;
                }
                /** @type {?} */
                var dateStr = this.ToString(date);
                /** @type {?} */
                var momentDate = momentHijri(dateStr, 'iD/iM/iYYYY');
                /** @type {?} */
                var day = momentDate.locale('en').format('D');
                /** @type {?} */
                var month = momentDate.locale('en').format('M');
                /** @type {?} */
                var year = momentDate.locale('en').format('Y');
                /** @type {?} */
                var ngDate = new ngBootstrap.NgbDate(+year, +month, +day);
                return ngDate;
            };
        DateFormatterService.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        DateFormatterService.ctorParameters = function () {
            return [
                { type: ngBootstrap.NgbDateParserFormatter }
            ];
        };
        return DateFormatterService;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-hijri-gregorian-datepicker.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxHijriGregorianDatepickerService = /** @class */ (function () {
        function NgxHijriGregorianDatepickerService() {
        }
        NgxHijriGregorianDatepickerService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxHijriGregorianDatepickerService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxHijriGregorianDatepickerService.ngInjectableDef = i0.defineInjectable({ factory: function NgxHijriGregorianDatepickerService_Factory() { return new NgxHijriGregorianDatepickerService(); }, token: NgxHijriGregorianDatepickerService, providedIn: "root" });
        return NgxHijriGregorianDatepickerService;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-hijri-gregorian-datepicker.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxHijriGregorianDatepickerComponent = /** @class */ (function () {
        function NgxHijriGregorianDatepickerComponent() {
        }
        /**
         * @return {?}
         */
        NgxHijriGregorianDatepickerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        NgxHijriGregorianDatepickerComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'lib-ngx-hijri-gregorian-datepicker',
                        template: "\n    <p>\n      ngx-hijri-gregorian-datepicker works!\n    </p>\n  "
                    }] }
        ];
        /** @nocollapse */
        NgxHijriGregorianDatepickerComponent.ctorParameters = function () { return []; };
        return NgxHijriGregorianDatepickerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/hijri-gregorian-datepicker/hijri-gregorian-datepicker.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var moment$1 = momentjs;
    /** @type {?} */
    var momentHijri$1 = moment_;
    var HijriGregorianDatepickerComponent = /** @class */ (function () {
        function HijriGregorianDatepickerComponent(dateFormatterService) {
            this.dateFormatterService = dateFormatterService;
            this.selectedDateChange = new i0.EventEmitter();
            this.readonly = false;
            this.isRequired = false;
            this.disabled = false;
        }
        Object.defineProperty(HijriGregorianDatepickerComponent.prototype, "DateType", {
            get: /**
             * @return {?}
             */ function () {
                return DateType;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        HijriGregorianDatepickerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (!this.selectedDateType) {
                    this.selectedDateType = DateType.Hijri;
                }
            };
        /**
         * @return {?}
         */
        HijriGregorianDatepickerComponent.prototype.getSelectedDate = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var formattedDate = this.dateFormatterService.ToString(this.selectedDate);
                if (this.selectedDateType == DateType.Hijri) {
                    return momentHijri$1(formattedDate, 'iD/iM/iYYYY').locale('en').format();
                }
                if (this.selectedDateType == DateType.Gregorian) {
                    return moment$1(formattedDate, 'D/M/YYYY').locale('en').format();
                }
            };
        /**
         * @return {?}
         */
        HijriGregorianDatepickerComponent.prototype.dateSelected = /**
         * @return {?}
         */
            function () {
                this.selectedDateChange.emit(this.selectedDate);
            };
        /**
         * @return {?}
         */
        HijriGregorianDatepickerComponent.prototype.hijriClick = /**
         * @return {?}
         */
            function () {
                if (this.selectedDateType == DateType.Hijri) {
                    return;
                }
                this.selectedDateType = DateType.Hijri;
                //to hijri
                this.selectedDate = this.dateFormatterService.ToHijri(this.selectedDate);
                this.selectedDateChange.emit(this.selectedDate);
            };
        /**
         * @return {?}
         */
        HijriGregorianDatepickerComponent.prototype.gregClick = /**
         * @return {?}
         */
            function () {
                if (this.selectedDateType == DateType.Gregorian) {
                    return;
                }
                this.selectedDateType = DateType.Gregorian;
                //to Gregorian
                this.selectedDate = this.dateFormatterService.ToGregorian(this.selectedDate);
                this.selectedDateChange.emit(this.selectedDate);
            };
        HijriGregorianDatepickerComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'hijri-gregorian-datepicker',
                        template: "\n    <div class=\"form-group\">\n      <label class=\"requiredInput\" for=\"input-birth-Date\">{{ label }} </label>\n\n      <div class=\"input-group\">\n\n          <input  class=\"form-control\"\n                  placeholder=\"d/M/yyyy\"\n                  [name]=\"label\"\n                  *ngIf=\"selectedDateType == DateType.Gregorian\"\n                  [(ngModel)]=\"selectedDate\"\n                  ngbDatepicker (click)=\"d.toggle()\"\n                  (dateSelect)=\"dateSelected()\"\n                  autocomplete=\"off\"\n                  #d=\"ngbDatepicker\"\n                  [readonly]=\"readonly\"\n                  [minDate]=\"minGreg\"\n                  [maxDate]=\"maxGreg\"\n                  [required]=\"isRequired\"\n                  [disabled]=\"disabled\">\n\n\n          <hijri-date-picker *ngIf=\"selectedDateType == DateType.Hijri\"\n                             [(selectedDate)]=\"selectedDate\"\n                             (selectedDateChange)=\"dateSelected()\"\n                             [readonly]=\"readonly\"\n                             [min]=\"minHijri\" [max]=\"maxHijri\"\n                             style=\"flex: 1 1 auto;\"\n                             [name]=\"label\"\n                             [isRequired]=\"isRequired\"\n                             [disabled]=\"disabled\">\n          </hijri-date-picker>\n\n          <div class=\"input-group-append\">\n                  <button class=\"btn btn-sm {{selectedDateType == DateType.Hijri ? 'btn-info focus active' :  'btn-outline-info'}}\" (click)=\"hijriClick()\"  [disabled]=\"disabled\" type=\"button\">\n                     {{hijriLabel ? hijriLabel : 'Hijri' }}\n                  </button>\n                  <button class=\"btn btn-sm {{selectedDateType == DateType.Gregorian ? 'btn-info focus active' :  'btn-outline-info'}}\" (click)=\"gregClick()\" [disabled]=\"disabled\" type=\"button\">\n                      {{GregLabel ? GregLabel : 'Gregorian' }}\n                  </button>\n           </div>\n\n      </div>\n  </div>\n"
                    }] }
        ];
        /** @nocollapse */
        HijriGregorianDatepickerComponent.ctorParameters = function () {
            return [
                { type: DateFormatterService }
            ];
        };
        HijriGregorianDatepickerComponent.propDecorators = {
            selectedDateType: [{ type: i0.Input }],
            selectedDate: [{ type: i0.Input }],
            selectedDateChange: [{ type: i0.Output }],
            label: [{ type: i0.Input }],
            readonly: [{ type: i0.Input }],
            isRequired: [{ type: i0.Input }],
            disabled: [{ type: i0.Input }],
            minHijri: [{ type: i0.Input }],
            maxHijri: [{ type: i0.Input }],
            minGreg: [{ type: i0.Input }],
            maxGreg: [{ type: i0.Input }],
            hijriLabel: [{ type: i0.Input }],
            GregLabel: [{ type: i0.Input }]
        };
        return HijriGregorianDatepickerComponent;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/hijri-gregorian-datepicker/IslamicI18n.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var WEEKDAYS = ['أحد', 'إثنين', 'ثلاثاء', 'أربعاء', 'خميس', 'جمعة', 'سبت'];
    /** @type {?} */
    var MONTHS = ['محرم', 'صفر', 'ربيع الأول', 'ربيع الآخر', 'جمادى الأولى', 'جمادى الآخرة', 'رجب', 'شعبان', 'رمضان', 'شوال',
        'ذو القعدة', 'ذو الحجة'];
    var IslamicI18n = /** @class */ (function (_super) {
        __extends(IslamicI18n, _super);
        function IslamicI18n() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} weekday
         * @return {?}
         */
        IslamicI18n.prototype.getWeekdayShortName = /**
         * @param {?} weekday
         * @return {?}
         */
            function (weekday) {
                return WEEKDAYS[weekday - 1];
            };
        /**
         * @param {?} month
         * @return {?}
         */
        IslamicI18n.prototype.getMonthShortName = /**
         * @param {?} month
         * @return {?}
         */
            function (month) {
                return MONTHS[month - 1];
            };
        /**
         * @param {?} month
         * @return {?}
         */
        IslamicI18n.prototype.getMonthFullName = /**
         * @param {?} month
         * @return {?}
         */
            function (month) {
                return MONTHS[month - 1];
            };
        /**
         * @param {?} date
         * @return {?}
         */
        IslamicI18n.prototype.getDayAriaLabel = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.day + "-" + date.month + "-" + date.year;
            };
        IslamicI18n.decorators = [
            { type: i0.Injectable }
        ];
        return IslamicI18n;
    }(ngBootstrap.NgbDatepickerI18n));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/hijri-gregorian-datepicker/hijri-datepicker/hijri-datepicker.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HijriDatepickerComponent = /** @class */ (function () {
        function HijriDatepickerComponent() {
            this.selectedDateChange = new i0.EventEmitter();
            this.readonly = false;
            this.isRequired = false;
            this.disabled = false;
        }
        /**
         * @return {?}
         */
        HijriDatepickerComponent.prototype.changeDate = /**
         * @return {?}
         */
            function () {
                this.selectedDateChange.emit(this.selectedDate);
            };
        /**
         * @return {?}
         */
        HijriDatepickerComponent.prototype.onBlur = /**
         * @return {?}
         */
            function () {
                if (!this.selectedDate) {
                    this.selectedDateChange.emit(null);
                }
            };
        HijriDatepickerComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'hijri-date-picker',
                        template: "<input\n    class=\"form-control hijriInput\"\n    [(ngModel)]=\"selectedDate\"\n    placeholder=\"d/M/yyyy\"\n    ngbDatepicker\n    (click)=\"d.toggle()\"\n    (dateSelect)=\"changeDate()\"\n    #d=\"ngbDatepicker\"\n    [readonly]=\"readonly\"\n    [minDate]=\"min\"\n    [maxDate]=\"max\"\n    [required]=\"isRequired\"\n    [name]=\"name\"\n    (blur)=\"onBlur()\"\n    [disabled]=\"disabled\" />\n",
                        providers: [
                            { provide: ngBootstrap.NgbCalendar, useClass: ngBootstrap.NgbCalendarIslamicUmalqura },
                            { provide: ngBootstrap.NgbDatepickerI18n, useClass: IslamicI18n }
                        ],
                        encapsulation: i0.ViewEncapsulation.None,
                        styles: [".hijriInput{border-top-left-radius:0;border-bottom-left-radius:0}.ngb-dp-weekday{width:2.1rem!important}"]
                    }] }
        ];
        /** @nocollapse */
        HijriDatepickerComponent.ctorParameters = function () { return []; };
        HijriDatepickerComponent.propDecorators = {
            selectedDate: [{ type: i0.Input }],
            selectedDateChange: [{ type: i0.Output }],
            readonly: [{ type: i0.Input }],
            isRequired: [{ type: i0.Input }],
            disabled: [{ type: i0.Input }],
            min: [{ type: i0.Input }],
            max: [{ type: i0.Input }],
            name: [{ type: i0.Input }]
        };
        return HijriDatepickerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/hijri-gregorian-datepicker/CustomNgbDateParserFormatter.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomNgbDateParserFormatter = /** @class */ (function (_super) {
        __extends(CustomNgbDateParserFormatter, _super);
        function CustomNgbDateParserFormatter(dateFormatString) {
            var _this = _super.call(this) || this;
            _this.dateFormatString = dateFormatString;
            _this.datePipe = new common.DatePipe('en-US');
            return _this;
        }
        /**
         * @param {?} date
         * @return {?}
         */
        CustomNgbDateParserFormatter.prototype.format = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                if (date === null) {
                    return '';
                }
                try {
                    return this.datePipe.transform(new Date(date.year, date.month - 1, date.day), this.dateFormatString);
                }
                catch (e) {
                    return '';
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        CustomNgbDateParserFormatter.prototype.parse = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                /** @type {?} */
                var returnVal;
                if (!value) {
                    returnVal = null;
                }
                else {
                    try {
                        /** @type {?} */
                        var dateParts = this.datePipe.transform(value, 'M-d-y').split('-');
                        returnVal = { year: parseInt(dateParts[2]), month: parseInt(dateParts[0]), day: parseInt(dateParts[1]) };
                    }
                    catch (e) {
                        returnVal = null;
                    }
                }
                return returnVal;
            };
        return CustomNgbDateParserFormatter;
    }(ngBootstrap.NgbDateParserFormatter));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-hijri-gregorian-datepicker.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxHijriGregorianDatepickerModule = /** @class */ (function () {
        function NgxHijriGregorianDatepickerModule() {
        }
        NgxHijriGregorianDatepickerModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            NgxHijriGregorianDatepickerComponent,
                            HijriGregorianDatepickerComponent,
                            HijriDatepickerComponent
                        ],
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            ngBootstrap.NgbModule
                        ],
                        providers: [
                            {
                                provide: ngBootstrap.NgbDateParserFormatter, useFactory: /**
                                 * @return {?}
                                 */ function () {
                                    return new CustomNgbDateParserFormatter('d/M/yyyy');
                                }
                            },
                            DateFormatterService
                        ],
                        exports: [HijriGregorianDatepickerComponent, NgxHijriGregorianDatepickerComponent]
                    },] }
        ];
        return NgxHijriGregorianDatepickerModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-hijri-gregorian-datepicker.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.DateType = DateType;
    exports.DateFormatterService = DateFormatterService;
    exports.NgxHijriGregorianDatepickerService = NgxHijriGregorianDatepickerService;
    exports.NgxHijriGregorianDatepickerComponent = NgxHijriGregorianDatepickerComponent;
    exports.HijriGregorianDatepickerComponent = HijriGregorianDatepickerComponent;
    exports.NgxHijriGregorianDatepickerModule = NgxHijriGregorianDatepickerModule;
    exports.ɵb = IslamicI18n;
    exports.ɵa = HijriDatepickerComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-hijri-gregorian-datepicker.umd.js.map